package process_execution

import "os/exec"

func ExecuteAndGetOutput(command string, args ...string) (string, error) {
	return ExecuteAndGetOutputC(nil, command, args...)
}

func ExecuteAndGetOutputC(cfg func(*exec.Cmd), command string, args ...string) (string, error) {
	process := exec.Command(command, args...)

	if cfg != nil {
		cfg(process)
	}

	outputBytes, err := process.CombinedOutput()
	outputString := ""

	if outputBytes != nil && len(outputBytes) > 0 {
		outputString = string(outputBytes)
	}

	return outputString, err
}
